function f_val = mn_autophase(phases,spectrum)
% Function for autophase of an NMR spectrum
% Inspired by Ernst JMagRes,1, 7-26, 1969 and 
% Craight and Marshall JMagRes, 76, 458-475, 1988


        fn=numel(spectrum);
        lpChange=-phases(2);
        rpChange=-phases(1);
        Rc=1i*(pi/180);
        lpCorr= linspace(0,1,fn)*lpChange;
        phaseCorr=(exp(Rc*(rpChange + lpCorr)))';
        spectrum=spectrum.*phaseCorr;
        
        f_val=max(real(spectrum))/min(real(spectrum));
        
        
    end